webdevqa.jp.net

よりスマートなVimリカバリ?

前のVimセッションがクラッシュすると、「スワップファイル...はすでに存在します!」というメッセージが表示されます。前のセッションで開いていたすべてのファイルに対して。

このVimリカバリプロンプトをよりスマートにできますか? (リカバリをオフに切り替えずに!)具体的には、次のことを考えています。

  • スワップされたバージョンに未保存の変更が含まれておらず、編集プロセスが実行されていない場合、Vimにスワップファイルを自動的に削除させることはできますか?
  • 復元されたファイルを新しい名前で保存し、ディスク上のファイルとマージしてから古いスワップファイルを削除するという提案されたプロセスを自動化して、最小限の操作で済むようにすることはできますか?特にスワップバージョンとディスクバージョンが同じ場合は、すべてが自動である必要があります。

SwapExists自動コマンドを発見しましたが、これらのタスクに役立つかどうかわかりません。

47
Bruno De Fraine

.vimrcにこれを置くことで、vimにスワップファイルを単一のローカルディレクトリに保存させています。

set directory=~/.vim/swap,.

他の利点の中でも、これにより、スワップファイルを一度に簡単に見つけることができます。これで、ラップトップの電源が切れたときなどに、大量のスワップファイルを置いてバックアップを開始したときに、cleanswapスクリプトを実行するだけです。

TMPDIR=$(mktemp -d) || exit 1
RECTXT="$TMPDIR/vim.recovery.$USER.txt"
RECFN="$TMPDIR/vim.recovery.$USER.fn"
trap 'rm -f "$RECTXT" "$RECFN"; rmdir "$TMPDIR"' 0 1 2 3 15
for q in ~/.vim/swap/.*sw? ~/.vim/swap/*; do
  [[ -f $q ]] || continue
  rm -f "$RECTXT" "$RECFN"
  vim -X -r "$q" \
      -c "w! $RECTXT" \
      -c "let fn=expand('%')" \
      -c "new $RECFN" \
      -c "exec setline( 1, fn )" \
      -c w\! \
      -c "qa"
  if [[ ! -f $RECFN ]]; then
    echo "nothing to recover from $q"
    rm -f "$q"
    continue
  fi
  CRNT="$(cat $RECFN)"
  if diff --strip-trailing-cr --brief "$CRNT" "$RECTXT"; then
      echo "removing redundant $q"
      echo "  for $CRNT"
      rm -f "$q"
  else
      echo $q contains changes
      vim -n -d "$CRNT" "$RECTXT"
      rm -i "$q" || exit
  fi
done

これにより、実際のファイルで最新のスワップファイルがすべて削除されます。一致しないものはすべてvimdiffウィンドウに表示されるので、保存されていない変更をマージできます。

--Chouser

37
Chouser

私はこれを発見しました:

http://vimdoc.sourceforge.net/htmldoc/diff.html#:DiffOrig

DiffOrigコマンドをコピーして.vimrcファイルに貼り付けましたが、これは魅力のように機能します。これにより、スワップファイルの回復が大幅に容易になります。なぜVIMにデフォルトで含まれていないのかわかりません。

急いでいる人のためのコマンドは次のとおりです。

 command DiffOrig vert new | set bt=nofile | r # | 0d_ | diffthis
    \ | wincmd p | diffthis
20
Jack Senechal

受け入れられた回答は、非常に重要なユースケースのために破棄されます。新しいバッファを作成し、保存せずに2時間入力すると、ラップトップがクラッシュするとします。提案されたスクリプトを実行すると唯一のレコードである.swpスワップファイルが削除されます。正しい修正が何であるかはわかりませんが、この場合、diffコマンドが同じファイルをそれ自体と比較することになります。以下の編集されたバージョンは、このケースをチェックし、ユーザーにファイルをどこかに保存する機会を与えます。

#!/bin/bash

SWAP_FILE_DIR=~/temp/vim_swp
IFS=$'\n'

TMPDIR=$(mktemp -d) || exit 1
RECTXT="$TMPDIR/vim.recovery.$USER.txt"
RECFN="$TMPDIR/vim.recovery.$USER.fn"
trap 'rm -f "$RECTXT" "$RECFN"; rmdir "$TMPDIR"' 0 1 2 3 15
for q in $SWAP_FILE_DIR/.*sw? $SWAP_FILE_DIR/*; do
  echo $q
  [[ -f $q ]] || continue
  rm -f "$RECTXT" "$RECFN"
  vim -X -r "$q" \
      -c "w! $RECTXT" \
      -c "let fn=expand('%')" \
      -c "new $RECFN" \
      -c "exec setline( 1, fn )" \
      -c w\! \
      -c "qa"
  if [[ ! -f $RECFN ]]; then
    echo "nothing to recover from $q"
    rm -f "$q"
    continue
  fi
  CRNT="$(cat $RECFN)"
  if [ "$CRNT" = "$RECTXT" ]; then
      echo "Can't find original file. Press enter to open vim so you can save the file. The swap file will be deleted afterward!"
      read
      vim "$CRNT"
      rm -f "$q"
  else if diff --strip-trailing-cr --brief "$CRNT" "$RECTXT"; then
      echo "Removing redundant $q"
      echo "  for $CRNT"
      rm -f "$q"
  else
      echo $q contains changes, or there may be no original saved file
      vim -n -d "$CRNT" "$RECTXT"
      rm -i "$q" || exit
  fi
  fi
done
16
coppit

素晴らしいヒントDiffOrigは完璧です。これは、現在のディレクトリの下の各スワップファイルで実行するために使用するbashスクリプトです。

#!/bin/bash

swap_files=`find . -name "*.swp"`

for s in $swap_files ; do
        orig_file=`echo $s | Perl -pe 's!/\.([^/]*).swp$!/$1!' `
        echo "Editing $orig_file"
        sleep 1
        vim -r $orig_file -c "DiffOrig"
        echo -n "  Ok to delete swap file? [y/n] "
        read resp
        if [ "$resp" == "y" ] ; then
                echo "  Deleting $s"
                rm $s
        fi
done

おそらく、もう少しエラーチェックと引用を使用することができますが、これまでのところ機能しています。

4
Mark Grimes

.vimrcにVIM作業ディレクトリを設定しない方がいいです。これは、スワップファイルをオンデマンドでスワップパスにコピーして重複をチェックし、それらを調整するchouserのスクリプトの変更です。これは急いで書いたので、実用化する前に必ず評価してください。

#!/bin/bash

if [[ "$1" == "-h" ]] || [[ "$1" == "--help" ]]; then
   echo "Moves VIM swap files under <base-path> to ~/.vim/swap and reconciles differences"
   echo "usage: $0 <base-path>"
   exit 0
fi

if [ -z "$1" ] || [ ! -d "$1" ]; then
   echo "directory path not provided or invalid, see $0 -h"
   exit 1
fi

echo looking for duplicate file names in hierarchy
swaps="$(find $1 -name '.*.swp' | while read file; do echo $(basename $file); done | sort | uniq -c | egrep -v "^[[:space:]]*1")"
if [ -z "$swaps" ]; then
   echo no duplicates found
   files=$(find $1 -name '.*.swp')
   if [ ! -d ~/.vim/swap ]; then mkdir ~/.vim/swap; fi
   echo "moving files to swap space ~./vim/swap"
   mv $files ~/.vim/swap
   echo "executing reconciliation"
   TMPDIR=$(mktemp -d) || exit 1
   RECTXT="$TMPDIR/vim.recovery.$USER.txt"
   RECFN="$TMPDIR/vim.recovery.$USER.fn"
   trap 'rm -f "$RECTXT" "$RECFN"; rmdir "$TMPDIR"' 0 1 2 3 15
   for q in ~/.vim/swap/.*sw? ~/.vim/swap/*; do
     [[ -f $q ]] || continue
     rm -f "$RECTXT" "$RECFN"
     vim -X -r "$q" \
         -c "w! $RECTXT" \
         -c "let fn=expand('%')" \
         -c "new $RECFN" \
         -c "exec setline( 1, fn )" \
         -c w\! \
         -c "qa"
     if [[ ! -f $RECFN ]]; then
       echo "nothing to recover from $q"
       rm -f "$q"
       continue
     fi
     CRNT="$(cat $RECFN)"
     if diff --strip-trailing-cr --brief "$CRNT" "$RECTXT"; then
         echo "removing redundant $q"
         echo "  for $CRNT"
         rm -f "$q"
     else
         echo $q contains changes
         vim -n -d "$CRNT" "$RECTXT"
         rm -i "$q" || exit
     fi
   done
else
   echo duplicates found, please address their swap reconciliation manually:
   find $1 -name '.*.swp' | while read file; do echo $(basename $file); done | sort | uniq -c | egrep '^[[:space:]]*[2-9][0-9]*.*'
fi
0
Mario Aguilera

これは.bashrcファイルにあります。このコードの一部に適切なクレジットを付与したいのですが、どこから取得したのか忘れてしまいました。

mswpclean(){

for i in `find -L -name '*swp'`
do
    swpf=$i
    aux=${swpf//"/."/"/"}
    orif=${aux//.swp/}
    bakf=${aux//.swp/.sbak}

    vim -r $swpf -c ":wq! $bakf" && rm $swpf
    if cmp "$bakf" "$orif" -s
    then rm $bakf && echo "Swap file was not different: Deleted" $swpf
    else vimdiff $bakf $orif
    fi
done

for i in `find -L -name '*sbak'`
do
    bakf=$i
    orif=${bakf//.sbak/}
    if test $orif -nt $bakf
    then rm $bakf && echo "Backup file deleted:" $bakf
    else echo "Backup file kept as:" $bakf
    fi
done }

これをプロジェクトのルートで実行すると、ファイルが異なる場合はvimdiffが開きます。その後、最後に保存されるファイルが保持されます。それを完璧にするには、最後のものを置き換える必要があります:

else echo "Backup file kept as:" $bakf

のようなものによって

else vim $bakf -c ":wq! $orif" && echo "Backup file kept and saved as:" $orif

しかし、私はそれを適切にテストする時間がありませんでした。

それが役に立てば幸い。

0
Miguel

find ./ -type f -name "。* sw [klmnop]" -delete

クレジット:@Shwaydogg https://superuser.com/questions/480367/whats-the-easiest-way-to-delete-vim-swapfiles-ive-already-recovered-from

最初にディレクトリに移動します

0
user3386050